Index: trunk/kBuild/doc/QuickReference-kmk.html
===================================================================
--- trunk/kBuild/doc/QuickReference-kmk.html	(revision 2168)
+++ trunk/kBuild/doc/QuickReference-kmk.html	(revision 2169)
@@ -297,4 +297,5 @@
 Since <em>all</em> the features are included, the quickness of this reference can be
 disputed. ;-)</p>
+<p>Features that are</p>
 <div class="section">
 <h1><a id="directives" name="directives">Directives</a></h1>
@@ -316,7 +317,7 @@
 ifneq &quot;a&quot; &quot;b&quot;
 ifneq 'a' 'b'
-if1of (set-a,set-b)
-ifn1of (set-a,set-b)
-if expression
+if1of (set-a,set-b)             [1]
+ifn1of (set-a,set-b)            [1]
+if expression                   [1]
 else
 endif
@@ -328,5 +329,5 @@
 sinclude file
 </pre>
-<p>Include another dependency file:</p>
+<p>Include another dependency file <a class="footnote-reference" href="#id15" id="id1" name="id1">[1]</a>:</p>
 <pre class="literal-block">
 includedep file
@@ -338,5 +339,5 @@
 override variable := value
 override variable += value
-override variable &lt;= value
+override variable &lt;= value      [1]
 override variable ?= value
 override define variable
@@ -354,9 +355,9 @@
 export variable := value
 export variable += value
-export variable &lt;= value
+export variable &lt;= value        [1]
 export variable ?= value
 unexport variable
 </pre>
-<p>Define a variable in the local context instead of the global one:</p>
+<p>Define a variable in the local context instead of the global one <a class="footnote-reference" href="#id15" id="id2" name="id2">[1]</a>:</p>
 <pre class="literal-block">
 local variable = value
@@ -509,34 +510,34 @@
 <tt class="docutils literal"><span class="pre">KBUILD_KMK_REVISION</span></tt></td>
 <td>The kBuild version string and the break down
-into individual components.</td>
-</tr>
-<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST</span></tt></td>
+into individual components. <a class="footnote-reference" href="#id15" id="id3" name="id3">[1]</a></td>
+</tr>
+<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST</span></tt> <a class="footnote-reference" href="#id15" id="id4" name="id4">[1]</a></td>
 <td>The host operating system.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST_ARCH</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST_ARCH</span></tt> <a class="footnote-reference" href="#id15" id="id5" name="id5">[1]</a></td>
 <td>The host architecture.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST_CPU</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KBUILD_HOST_CPU</span></tt> <a class="footnote-reference" href="#id15" id="id6" name="id6">[1]</a></td>
 <td>The host CPU <tt class="docutils literal"><span class="pre">kmk</span></tt> is built for, set to
 <tt class="docutils literal"><span class="pre">blend</span></tt> if not any particular CPU.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KBUILD_PATH</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KBUILD_PATH</span></tt> <a class="footnote-reference" href="#id15" id="id7" name="id7">[1]</a></td>
 <td>Where the kBuild scripts are.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KBUILD_BIN_PATH</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KBUILD_BIN_PATH</span></tt> <a class="footnote-reference" href="#id15" id="id8" name="id8">[1]</a></td>
 <td>Where the host specific kBuild binaries are.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK</span></tt>,
+<tr><td><tt class="docutils literal"><span class="pre">KMK</span></tt> <a class="footnote-reference" href="#id15" id="id9" name="id9">[1]</a>,
 <tt class="docutils literal"><span class="pre">MAKE</span></tt></td>
 <td>The name with which <tt class="docutils literal"><span class="pre">kmk</span></tt> was invoked. Using
 this variable in recipes has special meaning.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK_BUILTIN</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KMK_BUILTIN</span></tt> <a class="footnote-reference" href="#id15" id="id10" name="id10">[1]</a></td>
 <td>List of built-in commands.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK_FEATURES</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KMK_FEATURES</span></tt> <a class="footnote-reference" href="#id15" id="id11" name="id11">[1]</a></td>
 <td>List of <tt class="docutils literal"><span class="pre">kmk</span></tt> specific features.</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK_FLAGS</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KMK_FLAGS</span></tt> <a class="footnote-reference" href="#id15" id="id12" name="id12">[1]</a></td>
 <td><p class="first">The flags given to <tt class="docutils literal"><span class="pre">kmk</span></tt>. You can set this in
 the environment or a makefile to set flags.</p>
@@ -548,8 +549,8 @@
 </td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK_LEVEL</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KMK_LEVEL</span></tt> <a class="footnote-reference" href="#id15" id="id13" name="id13">[1]</a></td>
 <td>The number of levels of recursion (sub-makes).</td>
 </tr>
-<tr><td><tt class="docutils literal"><span class="pre">KMK_VERSION</span></tt></td>
+<tr><td><tt class="docutils literal"><span class="pre">KMK_VERSION</span></tt> <a class="footnote-reference" href="#id15" id="id14" name="id14">[1]</a></td>
 <td>The GNU <tt class="docutils literal"><span class="pre">make</span></tt> version number.</td>
 </tr>
@@ -1342,4 +1343,11 @@
 </blockquote>
 <hr class="docutils" />
+<table class="docutils footnote" frame="void" id="id15" rules="none">
+<colgroup><col class="label" /><col /></colgroup>
+<tbody valign="top">
+<tr><td class="label"><a name="id15">[1]</a></td><td><em>(<a class="fn-backref" href="#id1">1</a>, <a class="fn-backref" href="#id2">2</a>, <a class="fn-backref" href="#id3">3</a>, <a class="fn-backref" href="#id4">4</a>, <a class="fn-backref" href="#id5">5</a>, <a class="fn-backref" href="#id6">6</a>, <a class="fn-backref" href="#id7">7</a>, <a class="fn-backref" href="#id8">8</a>, <a class="fn-backref" href="#id9">9</a>, <a class="fn-backref" href="#id10">10</a>, <a class="fn-backref" href="#id11">11</a>, <a class="fn-backref" href="#id12">12</a>, <a class="fn-backref" href="#id13">13</a>, <a class="fn-backref" href="#id14">14</a>)</em> <tt class="docutils literal"><span class="pre">kmk</span></tt> only feature.</td></tr>
+</tbody>
+</table>
+<hr class="docutils" />
 <table class="docutils field-list" frame="void" rules="none">
 <col class="field-name" />
Index: trunk/kBuild/doc/QuickReference-kmk.txt
===================================================================
--- trunk/kBuild/doc/QuickReference-kmk.txt	(revision 2168)
+++ trunk/kBuild/doc/QuickReference-kmk.txt	(revision 2169)
@@ -8,4 +8,5 @@
 disputed. ;-)
 
+Features that are
 
 Directives
@@ -29,7 +30,7 @@
         ifneq "a" "b"
         ifneq 'a' 'b'
-        if1of (set-a,set-b)
-        ifn1of (set-a,set-b)
-        if expression
+        if1of (set-a,set-b)   		[1]
+        ifn1of (set-a,set-b)		[1]
+        if expression			[1]
         else
         endif
@@ -41,5 +42,5 @@
         sinclude file
 
-    Include another dependency file::
+    Include another dependency file [1]_::
 
         includedep file
@@ -51,5 +52,5 @@
         override variable := value
         override variable += value
-        override variable <= value
+        override variable <= value	[1]
         override variable ?= value
         override define variable
@@ -67,9 +68,9 @@
         export variable := value
         export variable += value
-        export variable <= value
+        export variable <= value        [1]
         export variable ?= value
         unexport variable
 
-    Define a variable in the local context instead of the global one::
+    Define a variable in the local context instead of the global one [1]_::
 
         local variable = value
@@ -178,28 +179,28 @@
 +--------------------------+--------------------------------------------------+
 | ``KBUILD_VERSION``,      | The kBuild version string and the break down     |
-| ``KBUILD_VERSION_MAJOR``,| into individual components.                      |
+| ``KBUILD_VERSION_MAJOR``,| into individual components. [1]_                 |
 | ``KBUILD_VERSION_MINOR``,|                                                  |
 | ``KBUILD_VERSION_PATCH``,|                                                  |
 | ``KBUILD_KMK_REVISION``  |                                                  |
 +--------------------------+--------------------------------------------------+
-| ``KBUILD_HOST``          | The host operating system.                       |
-+--------------------------+--------------------------------------------------+
-| ``KBUILD_HOST_ARCH``     | The host architecture.                           |
-+--------------------------+--------------------------------------------------+
-| ``KBUILD_HOST_CPU``      | The host CPU ``kmk`` is built for, set to        |
+| ``KBUILD_HOST`` [1]_     | The host operating system.                       |
++--------------------------+--------------------------------------------------+
+| ``KBUILD_HOST_ARCH`` [1]_| The host architecture.                           |
++--------------------------+--------------------------------------------------+
+| ``KBUILD_HOST_CPU`` [1]_ | The host CPU ``kmk`` is built for, set to        |
 |                          | ``blend`` if not any particular CPU.             |
 +--------------------------+--------------------------------------------------+
-| ``KBUILD_PATH``          | Where the kBuild scripts are.                    |
-+--------------------------+--------------------------------------------------+
-| ``KBUILD_BIN_PATH``      | Where the host specific kBuild binaries are.     |
-+--------------------------+--------------------------------------------------+
-| ``KMK``,                 | The name with which ``kmk`` was invoked. Using   |
+| ``KBUILD_PATH`` [1]_     | Where the kBuild scripts are.                    |
++--------------------------+--------------------------------------------------+
+| ``KBUILD_BIN_PATH`` [1]_ | Where the host specific kBuild binaries are.     |
++--------------------------+--------------------------------------------------+
+| ``KMK`` [1]_,            | The name with which ``kmk`` was invoked. Using   |
 | ``MAKE``                 | this variable in recipes has special meaning.    |
 +--------------------------+--------------------------------------------------+
-| ``KMK_BUILTIN``          | List of built-in commands.                       |
-+--------------------------+--------------------------------------------------+
-| ``KMK_FEATURES``         | List of ``kmk`` specific features.               |
-+--------------------------+--------------------------------------------------+
-| ``KMK_FLAGS``            | The flags given to ``kmk``. You can set this in  |
+| ``KMK_BUILTIN`` [1]_     | List of built-in commands.                       |
++--------------------------+--------------------------------------------------+
+| ``KMK_FEATURES`` [1]_    | List of ``kmk`` specific features.               |
++--------------------------+--------------------------------------------------+
+| ``KMK_FLAGS`` [1]_       | The flags given to ``kmk``. You can set this in  |
 |                          | the environment or a makefile to set flags.      |
 |                          |                                                  |
@@ -210,7 +211,7 @@
 |                          | through the environment from its parent.         |
 +--------------------------+--------------------------------------------------+
-| ``KMK_LEVEL``            | The number of levels of recursion (sub-makes).   |
-+--------------------------+--------------------------------------------------+
-| ``KMK_VERSION``          | The GNU ``make`` version number.                 |
+| ``KMK_LEVEL`` [1]_       | The number of levels of recursion (sub-makes).   |
++--------------------------+--------------------------------------------------+
+| ``KMK_VERSION`` [1]_     | The GNU ``make`` version number.                 |
 +--------------------------+--------------------------------------------------+
 | ``MAKECMDGOALS``         | The targets given to ``kmk`` on the command line.|
@@ -904,4 +905,8 @@
 -----
 
+.. [1] ``kmk`` only feature.
+
+-----
+
 :Status: $Id$
 :Copyright: Copyright (C) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,